//+------------------------------------------------------------------+ 
//|   _TRO_BreakoutRange                                             | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpldone@gmail.com                                         |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpldone.com/" 

//+------------------------------------------------------------------+
//|                                                   TSR_Ranges.mq4 |
//|                                         Copyright  2006, Ogeima |
//|                                             ph_bresson@yahoo.com |
//| made for FXiGoR for the TSR Trend Slope Retracement method       |
//| modified to the DYNAMIC Daily Range Breakout System             |
//+------------------------------------------------------------------+


#property indicator_chart_window
//---- input parameters

extern double  Risk_to_Reward_ratio =  3.0;

extern int myPeriod = PERIOD_D1 ;

int nDigits;

double     MinRange = 0 ; 
double     xRange   = 0 ; 
double     tRange   = 0 ; 

//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN1";
   }
   return(tfs);
}

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   if(Symbol()=="GBPJPY" || Symbol()=="EURJPY" || Symbol()=="USDJPY" || Symbol()=="GOLD")  nDigits = 2;
   else nDigits = 4;

   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   //----
   int R1=0,R5=0,R10=0,R20=0,RAvg=0;
   int RoomUp=0,RoomDown=0,StopLoss_Long=0,StopLoss_Short=0;
   double   SL_Long=0,SL_Short=0;
   double   low0=0,high0=0;
   string   Text="";
   int i=0;
   
    MinRange = 999999 ; 
    
   R1 =  (iHigh(NULL,myPeriod,1)-iLow(NULL,myPeriod,1))/Point;
   
   for(i=1;i<=5;i++)
      R5    =    R5  +  (iHigh(NULL,myPeriod ,i)-iLow(NULL,myPeriod,i))/Point;
      
   for(i=1;i<=10;i++)
      R10   =    R10 +  (iHigh(NULL,myPeriod,i)-iLow(NULL,myPeriod,i))/Point;
      
   for(i=1;i<=20;i++)
   { 
      xRange =    (iHigh(NULL,myPeriod,i)-iLow(NULL,myPeriod,i))/Point;
      R20    =    R20 +  xRange;
      if( xRange < MinRange ) {MinRange = xRange  ; }  
   }


   R5    = R5/5;
   R10   = R10/10;
   R20   = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4;    

   low0  =  iLow(NULL,myPeriod,0);
   high0 =  iHigh(NULL,myPeriod,0);
   
   RoomUp         =  RAvg - (Bid - low0)/Point;
   RoomDown       =  RAvg - (high0 - Bid)/Point;
   
   StopLoss_Long  =  RoomUp/Risk_to_Reward_ratio;
   SL_Long        =  Bid - StopLoss_Long*Point;
   
   StopLoss_Short =  RoomDown/Risk_to_Reward_ratio;
   SL_Short       =  Bid + StopLoss_Short*Point;

string   tPeriod  = TimeFrameToString( myPeriod ) ;

   Text =   "Average  "+tPeriod+" Range: " +  RAvg + "\n"  + 
            "Prev 01  "+tPeriod+" Range: " +  R1   + "\n" + 
            "Prev 05  "+tPeriod+" Range: " +  R5   + "\n" + 
            "Prev 10  "+tPeriod+" Range: " +  R10  + "\n" +
            "Prev 20  "+tPeriod+" Range: " +  R20  + "\n";
   Text =   Text +
            "Min  20  "+tPeriod+" Range: " + DoubleToStr(MinRange,0) + "\n" +
            "Room Up:     " + RoomUp              + "\n" +
            "Room Down: " + RoomDown            + "\n" ;

   Comment(Text);

   return(0);
  }
//+------------------------------------------------------------------+